--To put it very simply: The clbk_impact and on_collision functions can run several times in a row when the grenade actually collides if the collision itself is faulty, as the engine tends to handle that stuff, since the game never accounts for this, explosions can happen several times within a single frame due to the lack of checks.

--To fix this, all you need is a boolean check in the detonation function, it's that simple, OVERKILL has not fixed this until now. 

local frag_grenade_detonate = FragGrenade._detonate

function FragGrenade:_detonate(tag, unit, body, other_unit, other_body, position, normal, collision_velocity, velocity, other_velocity, new_velocity, direction, damage, ...)
	if self._detonated then
		return
	end
	
	self._detonated = true

	frag_grenade_detonate(self, tag, unit, body, other_unit, other_body, position, normal, collision_velocity, velocity, other_velocity, new_velocity, direction, damage, ...)
end